// -*- C -*-
/*!
 * @file  RTLight.c
 * @brief Sample component
 * @date  $Date$
 *
 * $Id$
 */
#define LCD_ENABLE

// <rtc-template block="header_inc">
#include <16f877a.h>
#include <stdlib.h>

#use fast_io(B)
#use fast_io(D)

#include "Sample.h"
#include "rtc_base.c"
#include "rtc_inport.c"
#include "rtc_outport.c"

// </rtc-template>

//============================================================
// Command parser: Level0
//============================================================
void parse_cmd_level0()
{
  rtc_msg_read();
  if (!rtc_msg_parity_check()) 
	{
	  RTM_ACK_PARITY_ERR;
	  return;
	}

  switch (rtc_msg_get(CMD_LEVEL0))
    {

    case RTC_PROFILE:
      _rtc_profile();
      break;
    case RTC_CMD:
	  rtc_parse_cmd();
      break;
    case INPORT_CMD:
      rtc_parse_inport_cmd();
      break;
	case OUTPORT_CMD:
      rtc_parse_outport_cmd();
      break;
    case USER_CMD:
      // user defined command parser
      break;
    case RTUNIT_CMD:

      break;
    default:

      break;
    }
  return;
}


//============================================================
// main function
//============================================================
int main (void)
{
  int cnt;
  cnt = 0;
  // RA setting example
    setup_adc_ports(NO_ANALOGS); // ADC: RA0, RA1, RA3
    set_tris_a(1);
  //setup_adc_ports(ALL_ANALOG);
  //setup_adc(ADC_CLOCK_INTERNAL);

  // RB setting example
  set_tris_b(0); // Output

  // RC setting example
  set_tris_c(0x81); // Output
 
  // RD setting example
   set_tris_d(0); // Output

  //----------------------------------------
  // Interrupts settings
  //
  // At least INT_RDA have to be enabled.
  enable_interrupts(INT_RDA);
  enable_interrupts(GLOBAL);

  delay_ms(8000);

  //ڑJn
  rtc_connect_proxy();

  while (1)
  {
    if (bkbhit)
      {
		parse_cmd_level0();
        delay_ms(10);    
      }

	rtc_mainloop();

    delay_ms(100);    
  }
  reset_cpu();
  return 0;
}


#define DEBUG
RtmRes rtc_on_initialize()
{ 
// Please implement a task for RTC_INITIALIZING state
#ifdef DEBUG
  rtc_outport_init();
  inport_init();
#endif
  return RTM_OK;
}


RtmRes rtc_on_shutdown()
{
// Please implement a task for RTC_INITIALIZING state
#ifdef DEBUG

#endif
  return RTM_OK;
}


RtmRes rtc_on_startup()
{ 
// Please implement a task for RTC_INITIALIZING state
#ifdef DEBUG

#endif
  return RTM_OK;
}

//dv:onActivate
RtmRes rtc_on_activate()
{
  // Please implement a task for RTC_ON_ACTIVATE
#ifdef DEBUG

#endif
  return RTM_OK;
}

RtmRes rtc_on_error()
{
  // Please implement a task for RTC_ON_ERROR state
#ifdef DEBUG

#endif
  return RTM_OK;
}

RtmRes rtc_on_reset()
{
  // Please implement a task for RTC_ON_RESET state
#ifdef DEBUG

#endif
  return RTM_OK;
}

RtmRes rtc_on_aborting()
{
// Please implement a task for RTC_ON_ABORTING state
#ifdef DEBUG

#endif
  return RTM_OK;
}


//dv:onExecute
RtmRes rtc_on_execute()
{ 
  // Please implement a task for RTC_ON_EXECUTE state
#ifdef DEBUG

  return RTM_OK;
}

//dv:onDeactivate
RtmRes rtc_on_deactivate()
{
  // Please implement a task for RTC_ON_DEACTIVATE state
#ifdef DEBUG

#endif
  return RTM_OK;
}

// end of main.c