// -*- C -*-
/*!
 * @file  rtc_inport.c
 * @brief RTC-L InPort management function for Sample component
 * @date  Tue Oct  4 21:57:16 2005
 *
 * $Id$
 */

/*
 * InPort Data Format:
 *
 * | 0  |    1     |    2    |        3      |  4  |...............|
 * |0xFF|INPORT_PUT|INPORT_ID|INPORT_DATA_LEN|data0|data1|.....|SUM|
 *
 */
#define INPORT_PUT      1
#define INPORT_ID       2
#define INPORT_DATA_LEN 3
#define INPORT_DATA_POS 4


// <rtc-template block="inport_decl">
// Number of InPort
#define INPORT_NUM 2


// InPort data buffer array and InPort length list
char* g_inport_p[INPORT_NUM];
int   g_inport_len[INPORT_NUM];



// InPort data declaration: Ref
#define REF_LEN 2
#define REF_ID  0
long g_RefIn[2];

// InPort data declaration: Sens
#define SENS_LEN 1
#define SENS_ID  1
int g_SensIn[1];

// </rtc-template>


// InPort initialization
void inport_init()
{
// <rtc-template block="inport_init">


  g_inport_p[REF_ID]   = (char*)g_refIn;
  g_inport_len[REF_ID] = REF_LEN;

  g_inport_p[SENS_ID]   = (char*)g_sensIn;
  g_inport_len[SENS_ID] = SENS_LEN;

  //g_SensIn[0] = 0;
// </rtc-template>
}


// InPort command parse function
void rtc_parse_inport_cmd()
{
//  putc(0xAB);
  int id;
  int i;
  unsigned int len;
  char* data_p;
  id = rtc_msg_get(INPORT_ID);
  if  (id > (INPORT_NUM - 1)) 
      {RTM_ACK_ERR;}
  else 
  {
    // set receive buffer pointer to temp buffer pointer
    data_p = (char*)g_inport_p[rtc_msg_get(INPORT_ID)];
    // get data length
    len = rtc_msg_get(INPORT_DATA_LEN);
  
    // Is input data length valid?
   // if (len != g_inport_len[rtc_msg_get(INPORT_ID)]) {RTM_ERR_RETURN;}
    // Copy receive data buffer to InPort data buffer
  
    for (i = 0; i < len; i++, data_p++)
      {
        *data_p = rtc_msg_get(INPORT_DATA_POS + i);
      }
     RTM_ACK_OK;
   }
//  rtc_msg_unlock();
  return;
}

// end of rtc_inport.c
